## Waves and Levels

import re

LevelPath = "media/ss/"

class Wave(object):
    def __init__(self):
        self.baddies = []
        self.iterat = None
        
    def add(self, bad):
        self.baddies.append(bad)
        
    def __iter__(self):
        self.iterat = iter(self.baddies)
        return self
    
    def next(self):
        return self.iterat.next()
        
class Level(object):
    WaveLine = re.compile("WAVE.*",re.I)
    CommentLine = re.compile("#.*")
    BaddieLine = re.compile("BADDIE (\w+) (\d+),(\d+)",re.I)
    
    
    def __init__(self):
        self.waves = []
        self.iterat = None
        
    def gentest1(self):
        w = Wave()
        w.add("A")
        w.add("B")
        w.add("C")
        self.waves.append(w)
        
        self.iterat = iter(self.waves)


    def load(self, filename = 'level.lvl'):
        
        try:
            f = open(LevelPath + filename)
        except Exception,e:
            print e
            return
        
        w = None
        
        for line in f:
            tm = self.CommentLine.match(line)         ### Comment Line
            if tm:
                continue

            tm = self.WaveLine.match(line)
            if tm:                                    ### New Wave
                if w:
                    self.waves.append(w)              ## Append old wave to list
                w = Wave()                            ## Create a new wave to populate
                continue
        
            tm = self.BaddieLine.match(line)
            if tm:                                    ### Baddie
                w.add(tm.group(1))                    ## Group 1 - Name of Baddie Group 2,3 = x,y 
                continue
        
        self.waves.append(w)
        
        self.iterat = iter(self.waves)


    def next(self):
        try:
            nextw = self.iterat.next()
        except StopIteration:
            nextw = None
            
        return nextw





























